Subject: bug#7833: automake uses two different values for DejaGNU srcdir

From: Stefano Lattarini <[email-masked]>
Date: Thu, 13 Jan 2011 21:21:06 +0100

On Thursday 13 January 2011, Ian Lance wrote:
> Stefano Lattarini <[email-masked]> writes:
> 
> > On Thursday 13 January 2011, Ian Lance wrote:
> >> Stefano Lattarini <[email-masked]> writes:
> >> 
> >> > Are you sure about this?  Why then is the attached testcase working
> >> > (for me at least)?
> >> 
> >> I guess I'm not sure what point you are trying to make with your
> >> example.  A relative srcdir will sometimes work and sometimes fail.  It
> >> seemed to me an absolute srcdir should always work, but Ralf has pointed
> >> out a somewhat obscure case where it too can fail.  Either way, it makes
> >> no sense for automake to use two different values for srcdir.  It should
> >> pick one and stick to it.
> >> 
> > Yes, but my testcase *should* show (at least in my understanding)
> > that in the dejagnu tests both the TCL-level '$srcdir' variable and
> > the environment variable 'srcdir' contain an absolute path, even
> > when the Makefile variable $(srcdir) contains a relative path (in
> > this case, `.').
> 
> Take a look at the site.exp file and see what value is in there for
> srcdir: relative or absolute?
>
Relative (as I expected):

  $ cat dejagnu-srcdir-is-absolute.dir/site.exp 
  ## these variables are automatically generated by make ##
  # Do not edit here.  If you wish to override these values
  # edit the last section
  set srcdir .
  set objdir /home/stefano/src/automake/tests/dejagnu-srcdir-is-absolute.dir
  ## All variables above are generated by configure. Do Not Edit ##

But then, why the testcase suceeds?  I would expect it to fail!

Thanks,
  Stefano